program define gkleinspady_d2, sortpreserve
    version 8.2
    args todo b lnf g negH
    tempvar xb Gn gn gnd1
    mleval `xb' = `b'

    qui summ `xb'
    local hn = $stdwidth * r(sd)

    quietly {
      // Nadaraya-Watson kernel based on Wolfgang Haerdle (1991, Ch. 2 and 5): Smoothing techniques. Springer, Berlin
      // Indirect slope estimator for negative Hessian related to Thomas M. Stoker (1994): Equivalence of direct, indirect, and slope estimators of average derivatives, In: Nonparametric and Semiparametric Methods in Econometrics and Statistics, Fifth International Symposium. Cambridge U, Cambrigde, pp. 99-118
      tempvar z fh rh kz kzy fd1 kzd1 obssrt
      gen double `z'  = 0 if $ML_samp
      gen double `fh' = 0 if $ML_samp
      gen double `rh' = 0 if $ML_samp
      gen double `kz' = 0 if $ML_samp
      gen double `kzy' = 0 if $ML_samp
      gen double `fd1' = 0 if $ML_samp
      gen double `kzd1' = 0 if $ML_samp
      count if `xb' < . 
      local np = r(N)
      summ `xb' if $ML_samp, meanonly
      local nuobs = r(N)
      gen `obssrt' = _n if $ML_samp
      sort `xb' `obssrt'
      local i = 1
      while `i' <= `np' {
        local xo = `xb'[`i']
        replace `z' = (`xo' - `xb') / `hn' if $ML_samp
        replace `kz' = (1/(sqrt(2*_pi)))*exp(-.5*`z'*`z')  // Gaussian
        replace `kzd1' = -`z'*(1/(sqrt(2*_pi)))*exp(-.5*`z'*`z')  // Gaussian, first derivative
        * replace `kz' = (1/(sqrt(2*_pi)))*exp(-`z'*`z'/2)*(3/2-`z'*`z'/2)  // Martins (JApplEcon 16 2001, 23-39)
        * replace `kzd1' = -(1/(2*sqrt(2*_pi)))*exp(-`z'*`z'/2)*`z'*(5-`z'*`z')  // Martins (JApplEcon 16 2001, 23-39), first derivative
        * replace `kz' = (21/64)*(1-5*(`z'/5)*(`z'/5)+7*(`z'/5)*(`z'/5)*(`z'/5)*(`z'/5)-3*(`z'/5)*(`z'/5)*(`z'/5)*(`z'/5)*(`z'/5)*(`z'/5))  if abs(`z') < 5  // Horowitz (JEmetrics 58 1993, 49-70)
        * replace `kzd1' =  (21/500000)*`z'*(5-`z'*`z')*(125-9*`z'*`z')  if abs(`z') < 5  // Horowitz (JEmetrics 58 1993, 49-70), first derivative
        replace `kzy' = $ML_y1*`kz'
        summ `kz', meanonly 
        replace `fh' = (1 / (`nuobs'*`hn')) * `r(sum)' in `i'
        summ `kzy', meanonly 
        replace `rh' = (1 / (`nuobs'*`hn')) * `r(sum)' in `i'
        summ `kzd1', meanonly 
        replace `fd1' = (1 / (`nuobs'*`hn'*`hn')) * `r(sum)' in `i'         
        replace `kz'  = 0 if $ML_samp
        replace `kzy' = 0 if $ML_samp
        replace `kzd1' = 0 if $ML_samp
        local i = `i' + 1
        }
      gen double `Gn' = `rh'/`fh' if _n <= `np'
      replace `Gn'=0 if `Gn'<0
      rename `fh' `gn'
      replace `gn' = 0 if `gn'<0
      rename `fd1' `gnd1'

      mlsum `lnf' = $ML_y1 * ln(`Gn') + (1-$ML_y1) * ln(1-`Gn')
      if (`todo'==0 | `lnf'>=.)  exit
      
      mlvecsum `lnf' `g' = $ML_y1 * `gn'/`Gn' - (1-$ML_y1) * `gn'/(1-`Gn')
      if (`todo'==1 | `lnf'>=.)  exit

      mlmatsum `lnf' `negH' = $ML_y1 * ( `gnd1'/`Gn' - (`gn'/`Gn')*(`gn'/`Gn') ) - (1-$ML_y1) * ( `gnd1'/(1-`Gn') + (`gn'/(1-`Gn'))*(`gn'/(1-`Gn')) )
      }
end 
